// ==============================================================================================
// VRmUsbCam C API Property Identifiers v2.6.1.0
// Copyright VRmagic 2004-2006
// ==============================================================================================

#ifndef VRMUSBCAM2PROPS_H
#define VRMUSBCAM2PROPS_H

#ifndef VRM_PROPID
#define VRM_PROPID(name) VRM_PROPID_##name
#endif

typedef enum _VRmPropId {

	VRM_PROPID(CAM_EXPOSURE_TIME_F) = 0x1001,

	VRM_PROPID(CAM_SIGNAL_SOURCE_E) = 0x1009,
	VRM_PROPID(CAM_SIGNAL_SOURCE_UNKNOWN) = VRM_PROPID(CAM_SIGNAL_SOURCE_E)<<16,
	VRM_PROPID(CAM_SIGNAL_SOURCE_SVIDEO),
	VRM_PROPID(CAM_SIGNAL_SOURCE_COMPOSITE),
	VRM_PROPID(CAM_SIGNAL_SOURCE_YC),

	VRM_PROPID(CAM_FRAMERATE_MAX_F) = 0x100A,

	VRM_PROPID(CAM_HBLANK_DURATION_I) = 0x1010,
	VRM_PROPID(CAM_VBLANK_DURATION_I),
	VRM_PROPID(CAM_TRG2EXP_TIME_F),

	VRM_PROPID(CAM_GAIN_RED_I) = 0x1020,
	VRM_PROPID(CAM_GAIN_GREEN_I),
	VRM_PROPID(CAM_GAIN_BLUE_I),
	VRM_PROPID(CAM_GAIN_MONOCHROME_I),
	VRM_PROPID(CAM_AUTO_GAIN_B),
	VRM_PROPID(CAM_AUTO_GAIN_MAX_I),
	VRM_PROPID(CAM_OFFSET_RED_I),
	VRM_PROPID(CAM_OFFSET_GREEN_I),
	VRM_PROPID(CAM_OFFSET_BLUE_I),
	VRM_PROPID(CAM_BRIGHTNESS_I),
	VRM_PROPID(CAM_CONTRAST_I),
	VRM_PROPID(CAM_SATURATION_I),
	VRM_PROPID(CAM_HUE_I),

	VRM_PROPID(CAM_ANTI_BLOOMING_B) = 0x1030,
	VRM_PROPID(CAM_ANTI_BLOOMING_VOLTAGE_F),

	VRM_PROPID(CAM_SENSOR_SIZE_I) = 0x1040,

	VRM_PROPID(CAM_MONOCHROME_MODE_B) = 0x1042,
	VRM_PROPID(CAM_GLOBAL_SHUTTER_B),
	VRM_PROPID(CAM_VIDEO_STANDARD_E),
	VRM_PROPID(CAM_VIDEO_STANDARD_UNKNOWN) = VRM_PROPID(CAM_VIDEO_STANDARD_E)<<16,
	VRM_PROPID(CAM_VIDEO_STANDARD_PAL),
	VRM_PROPID(CAM_VIDEO_STANDARD_NTSC),

	VRM_PROPID(CAM_HIGH_DYNAMIC_MODE_B) = 0x1050,
	VRM_PROPID(CAM_HIDYN_KNEE_COUNT_I),
	VRM_PROPID(CAM_HIDYN_AUTO_RATIO_B),
	VRM_PROPID(CAM_HIDYN_AUTO_RATIO1_I),
	VRM_PROPID(CAM_HIDYN_AUTO_RATIO2_I),
	VRM_PROPID(CAM_HIDYN_AUTO_RATIO3_I),
	VRM_PROPID(CAM_HIDYN_AUTO_RATIO4_I),
	VRM_PROPID(CAM_HIDYN_EXPOSURE_KNEE1_F),
	VRM_PROPID(CAM_HIDYN_EXPOSURE_KNEE2_F),
	VRM_PROPID(CAM_HIDYN_EXPOSURE_KNEE3_F),
	VRM_PROPID(CAM_HIDYN_EXPOSURE_KNEE4_F),
	VRM_PROPID(CAM_HIDYN_STEP_VOLTAGE1_F),
	VRM_PROPID(CAM_HIDYN_STEP_VOLTAGE2_F),
	VRM_PROPID(CAM_HIDYN_STEP_VOLTAGE3_F),
	VRM_PROPID(CAM_HIDYN_STEP_VOLTAGE4_F),
	
	VRM_PROPID(CAM_TEMPERATURE_F) = 0x1060,

	VRM_PROPID(CAM_VREF1_ADJUST_I) = 0x1070,

	VRM_PROPID(CAM_RESET_LEVEL_ADJ_I) = 0x1500,
	VRM_PROPID(CAM_PIXEL_BIAS_ADJ_I),
	VRM_PROPID(CAM_VBLANK_DURATION_PIXELS_I),

	VRM_PROPID(CAM_GAIN_DOUBLING_B) = 0x1600,

	VRM_PROPID(DEVICE_HARDWARE_REVISION_I) = 0x2000,
	VRM_PROPID(DEVICE_FIRMWARE_REVISION_I),
	VRM_PROPID(DEVICE_NV_MEM_TOTAL_I),
	VRM_PROPID(DEVICE_NV_MEM_FREE_I),

	VRM_PROPID(CAM_PIXEL_CLOCK_F) = 0x2100,
	VRM_PROPID(CAM_REFERENCE_FREQ_ADJ_I),
	VRM_PROPID(CAM_AUTO_PIXEL_CLOCK_B),

	VRM_PROPID(CAM_ILLUMINATION_INTENSITY_F) = 0x2110,

	VRM_PROPID(CAM_TRIGGER_POLARITY_E) = 0x2120,
	VRM_PROPID(CAM_TRIGGER_POLARITY_POS_EDGE) = VRM_PROPID(CAM_TRIGGER_POLARITY_E)<<16,
	VRM_PROPID(CAM_TRIGGER_POLARITY_NEG_EDGE),
	VRM_PROPID(CAM_TRIGGER_POLARITY_POS_LEVEL),
	VRM_PROPID(CAM_TRIGGER_POLARITY_NEG_LEVEL),

	VRM_PROPID(CAM_TRIGGER_DELAY_F) = 0x2121,

	VRM_PROPID(CAM_STROBE_POLARITY_E) = 0x2130,
	VRM_PROPID(CAM_STROBE_POLARITY_DISABLED) = VRM_PROPID(CAM_STROBE_POLARITY_E)<<16,
	VRM_PROPID(CAM_STROBE_POLARITY_POS),
	VRM_PROPID(CAM_STROBE_POLARITY_NEG),

	VRM_PROPID(CAM_STROBE_DELAY_F) = 0x2131,
	VRM_PROPID(CAM_STROBE_WIDTH_F),

	VRM_PROPID(GRAB_READOUT_ORIGIN_POINT_I) = 0x3001,
	VRM_PROPID(GRAB_HOST_RINGBUFFER_SIZE_I),
	VRM_PROPID(GRAB_FRAMERATE_AVERAGE_F),
	VRM_PROPID(GRAB_FRAMERATE_ESTIMATED_F),

	VRM_PROPID(GRAB_USER_ROI_RECT_I) = 0x3010,

	VRM_PROPID(GRAB_MODE_E) = 0x3080,
	VRM_PROPID(GRAB_MODE_FREERUNNING) = VRM_PROPID(GRAB_MODE_E)<<16,
	VRM_PROPID(GRAB_MODE_TRIGGERED_EXT),
	VRM_PROPID(GRAB_MODE_TRIGGERED_SOFT),
	VRM_PROPID(GRAB_MODE_TRIGGERED_SOFT_EXT),
	VRM_PROPID(GRAB_MODE_FREERUNNING_SEQUENTIAL),

	VRM_PROPID(GRAB_TRIGGER_TIMEOUT_F) = 0x3081,

	VRM_PROPID(FILTER_MASTER_GAMMA_F) = 0x3100,
	VRM_PROPID(FILTER_MASTER_LUMINANCE_I),
	VRM_PROPID(FILTER_MASTER_CONTRAST_F),
	VRM_PROPID(FILTER_MASTER_BLACKLEVEL_I),

	VRM_PROPID(FILTER_RED_GAMMA_F) = 0x3110,
	VRM_PROPID(FILTER_RED_LUMINANCE_I),
	VRM_PROPID(FILTER_RED_CONTRAST_F),

	VRM_PROPID(FILTER_GREEN_GAMMA_F) = 0x3120,
	VRM_PROPID(FILTER_GREEN_LUMINANCE_I),
	VRM_PROPID(FILTER_GREEN_CONTRAST_F),

	VRM_PROPID(FILTER_BLUE_GAMMA_F) = 0x3130,
	VRM_PROPID(FILTER_BLUE_LUMINANCE_I),
	VRM_PROPID(FILTER_BLUE_CONTRAST_F),

	VRM_PROPID(PLUGIN_AUTO_EXPOSURE_B) = 0x3200,
	VRM_PROPID(PLUGIN_AUTO_EXPOSURE_MAX_F),
	VRM_PROPID(PLUGIN_AUTO_EXPOSURE_TARGET_MEAN_VALUE_I),
	VRM_PROPID(PLUGIN_AUTO_EXPOSURE_TARGET_MEAN_VALUE_TOLERANCE_I),

	VRM_PROPID(PLUGIN_AUTO_RESET_LEVEL_B) = 0x3210,

	VRM_PROPID(PLUGIN_AUTO_WHITE_BALANCE_FILTER_B) = 0x3220,
	VRM_PROPID(PLUGIN_AUTO_WHITE_BALANCE_GAINS_B),
	VRM_PROPID(PLUGIN_AUTO_WHITE_BALANCE_ROI_RECT_I),

	VRM_PROPID(CONVERTER_BAYER_HQ_B) = 0x4000,
	VRM_PROPID(CONVERTER_FLIP_H_B),
	VRM_PROPID(CONVERTER_FLIP_V_B),
	VRM_PROPID(CONVERTER_PREFER_GRAY_OUTPUT_B)

} VRmPropId;

#endif//VRMUSBCAM2PROPS_H
