/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLBACKGROUND_H__
#define __TLBACKGROUND_H__


#include "tlVision.h"


class tlBackground
{
private:
	float     *mean;
	float     *variance;


	// learning params
	int   learn;
  int   adapt;
	float Vmin, Vmax;
	float alpha;
	float K;
	float Koffset;

public:

  int       width, height;
  int       pixelWidth;
  tl_format format;  
  
  tlBackground  ();
  tlBackground  (float Vmin, float Vmax, float alpha, float K, float Koffset);
	virtual ~tlBackground ();

  // set parameters
  int setParam (float Vmin, float Vmax, float alpha, float K, float Koffset);
  int setLearn (int val) { return learn = val; };
  int setAdapt (int val) { return adapt = val; };

	// background definition and learning
	int init		(tlImage *image, int adapt = 0, int learn = 0);
	int update	(tlImage *image);
  int update  (tlImage *image, tlRect *rect);

	// background display
	int get			    (tlImage *dest);
  int getVariance (tlImage *dest);

  // foreground extraction
	int filter	(tlImage *image);
  int filter  (tlImage *image, tlRect *rect);
};


#endif
