/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLCAMERA_H__
#define __TLCAMERA_H__


#include "tlVision.h"
#include "tlSource.h"




// interface
class tlCamera : public tlSource
{
protected:
  int  Tx, Ty, Tz;
  int  Rx, Ry, Rz;
  bool calibrated;

public:
  tlCamera ();
  virtual ~tlCamera ();

  int         setPosition     (int Tx, int Ty, int Tz);
  int         setOrientation  (int Rx, int Ry, int Rz);

  bool        isCalibrated    () { return calibrated; };
  int         getTx           () { return Tx; };
  int         getTy           () { return Ty; };
  int         getTz           () { return Tz; };
  int         getRx           () { return Rx; };
  int         getRy           () { return Ry; };
  int         getRz           () { return Rz; };

  virtual int grab            (tlImage *image)                = 0;
  virtual int grab            (tlImage *image, tlRect *rect)  = 0;
  virtual int grabQueued      (tlImage *image)                = 0;
  virtual int grabQueued      (tlImage *image, tlRect *rect)  = 0;
};

#endif

