/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLCAMERASVS_H__
#define __TLCAMERASVS_H__


#define TL_CAMERA_SVS_FILENAME  "svs.ini"


#include "tlVision.h"
#include "tlCameraSVSBase.h"

#include "svsclass.h"




// interface
class tlCameraSVS : public tlCameraSVSBase
{
private:
  tlSource        *leftSource;
  tlSource        *rightSource;

public:
  tlCameraSVS  ();
  tlCameraSVS  (char *filename);
  virtual ~tlCameraSVS ();

  tlSource    *getLeftSource    () { return leftSource;  };
  tlSource    *getRightSource   () { return rightSource; };

  int         setSource       (tlSource *leftSource, tlSource *rightSource);
  int         setLeftSource   (tlSource *source);
  int         setRightSource  (tlSource *source);

  virtual int grab            (tlImage *image);
  virtual int grab            (tlImage *image, tlRect *rect);
  virtual int grabQueued      (tlImage *image);
  virtual int grabQueued      (tlImage *image, tlRect *rect);

  virtual int grab            (tlImage *image, tlImage *disparity);
  virtual int grab            (tlImage *image, tlImage *disparity, tlRect *rect);
  virtual int grabQueued      (tlImage *image, tlImage *disparity);
  virtual int grabQueued      (tlImage *image, tlImage *disparity, tlRect *rect);

};

#endif
