/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLCAMERASTEREO_H__
#define __TLCAMERASTEREO_H__


#include "tlVision.h"
#include "tlCamera.h"



// interface
class tlCameraStereo : public tlCamera
{
protected:

public:
  tlCameraStereo ();
  virtual ~tlCameraStereo ();

  virtual int grab          (tlImage *image) = 0;
  virtual int grab          (tlImage *image, tlRect *rect) = 0;
  virtual int grabQueued    (tlImage *image) = 0;
  virtual int grabQueued    (tlImage *image, tlRect *rect) = 0;

  virtual int grab          (tlImage *image, tlImage *disparity) = 0;
  virtual int grab          (tlImage *image, tlImage *disparity, tlRect *rect) = 0;
  virtual int grabQueued    (tlImage *image, tlImage *disparity) = 0;
  virtual int grabQueued    (tlImage *image, tlImage *disparity, tlRect *rect) = 0;

  virtual int getDisparity  (tlImage *disparity) = 0;
  virtual int getDisparity  (tlImage *disparity, tlRect *rect) = 0;

  virtual int getDisparity  (tlImage *leftImage, tlImage *rightImage, tlImage *disparity) = 0;
  virtual int getDisparity  (tlImage *leftImage, tlImage *rightImage, tlImage *disparity, tlRect *rect) = 0;

  virtual int toWorld       (tlLocation *location) = 0;
  virtual int toWorld       (tlLocation *location, tlLocation *dest) = 0;
  virtual int toImage       (tlLocation *location) = 0;
  virtual int toImage       (tlLocation *location, tlLocation *dest) = 0;
};

#endif

