/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////



#ifndef __TLCOLORMODEL_H__
#define __TLCOLORMODEL_H__


#include "tlVision.h"
#include "tlColor.h"


#define TL_COLOR_MODEL_DETECTION_THRESHOLD		25



class tlColorModel
{
private:
	tlHist2D  *NRGHist;
	tlHist2D  *HSHist;
	tl_format format;

public:
	tlColorModel  ();
	tlColorModel  (char *filebase);
	virtual ~tlColorModel ();

	tlHist2D *getNRGHist () { return NRGHist; };
	tlHist2D *getHSHist  () { return HSHist; };

	int reset ();
	int finalize ();

	int save (char *filebase);
	int load (char *filebase);

	int train (tlImage *image);
	int train (tlImage *image, tlPoint *point);
	int train (tlImage *image, tlChain *chain);

	int filter (tlImage *image, int threshold = TL_COLOR_MODEL_DETECTION_THRESHOLD);
	int filter (tlImage *image, tlRect *rect, int threshold = TL_COLOR_MODEL_DETECTION_THRESHOLD);

  int test   (tlColor *color, int threshold = TL_COLOR_MODEL_DETECTION_THRESHOLD);
};


#endif

