/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLCONVOLUTION_H__
#define __TLCONVOLUTION_H__


#include "tlVision.h"


// planar convolution
int tl_convolution (tlPixel *src, int width, int height, int pixel_width, char  *kernel, int kernel_width, int kernel_height, tlRect *rect, tlPixel *dest);
int tl_convolution (tlPixel *src, int width, int height, int pixel_width, float *kernel, int kernel_width, int kernel_height, tlRect *rect, tlPixel *dest);

// separable convolution
int tl_convolution_x (tlPixel *src, int width, int height, int pixel_width, char  *kernel, int kernel_size, tlRect *rect, int     *dest);
int tl_convolution_x (tlPixel *src, int width, int height, int pixel_width, float *kernel, int kernel_size, tlRect *rect, float   *dest);
int tl_convolution_x (tlPixel *src, int width, int height, int pixel_width, float *kernel, int kernel_size, tlRect *rect, tlPixel *mask, float   *dest);
int tl_convolution_y (int     *src, int width, int height, int pixel_width, char  *kernel, int kernel_size, tlRect *rect, tlPixel *dest);
int tl_convolution_y (float   *src, int width, int height, int pixel_width, float *kernel, int kernel_size, tlRect *rect, tlPixel *dest);
int tl_convolution_y (float   *src, int width, int height, int pixel_width, float *kernel, int kernel_size, tlRect *rect, tlPixel *mask, tlPixel *dest);

// utilities
int
tl_create_gaussian_kernel (int   ksize, float sigma, float *kernel);


#endif
