/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLDIGITIZERDT3130_H__
#define __TLDIGITIZERDT3130_H__


#include "tlVision.h"
#include "tlDigitizer.h"

#include "olfgapi.h"
#include "olimgapi.h"
#include "olwintyp.h"
#include "DtColorSDK.h"

// debug verbosity
extern int tlVerbose;


// interface
class tlDigitizerDT3130 : public tlDigitizer
{
private:
  char                name[OLC_MAX_ALIAS_STR_SIZE];
  OLT_IMG_DEV_ID      devId;
  OLT_FG_FRAME_ID     frameId;	
  OLT_FG_FRAME_INFO   frameInfo;	
  OLT_FG_ACQJOB_ID    jobId;	
  OLT_FG_PASSJOB_ID   jobPassId;

public:
  tlDigitizerDT3130         ();
  tlDigitizerDT3130         (int width, int height);
  tlDigitizerDT3130         (int width, int height, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual ~tlDigitizerDT3130        ();

  virtual int open          (int index = 0);
  virtual int open          (int width, int height, int index = 0);
          int open          (int width, int height, int index, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual int close         ();

  virtual int setChannel    (int channel, unsigned short input);
  virtual int setInput      (unsigned short input);
  virtual int setFrameRate  (int fps);
  virtual int setSize       (int width, int height);

  virtual int grab          (tlImage *image);
  virtual int grab          (tlImage *image, tlRect *rect);
  virtual int grabQueued    (tlImage *image);
  virtual int grabQueued    (tlImage *image, tlRect *rect);
};


#endif

