/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLDIGITIZERDX_H__
#define __TLDIGITIZERDX_H__



#include "tlVision.h"
#include "tlDigitizer.h"



// DirectX objects
class SampleGrabberCallback;
class DXGrabObjects;



// interface
class tlDigitizerDX : public tlDigitizer
{
private:
  bool                    imageReady;
  SampleGrabberCallback   *cb;

protected:
  DXGrabObjects           *grabber;
  BYTE                    *buffer;
  int                     index;
  int                     fps;

public:
  tlDigitizerDX  ();
  tlDigitizerDX  (int width, int height);
  virtual ~tlDigitizerDX ();

  virtual int open            (int index = 0);
  virtual int open            (int width, int height, int index = 0);
  virtual int close           ();

  virtual int setSize         (int width, int height);

  virtual int grab            (tlImage *image);
  virtual int grab            (tlImage *image, tlRect *rect);
  virtual int grabQueued      (tlImage *image);
  virtual int grabQueued      (tlImage *image, tlRect *rect);

  int setFrameRate (int fps);
};


#endif

