/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLDIGITIZERPXC200_H__
#define __TLDIGITIZERPXC200_H__


#include "..\..\external\pxc\include\pxc.h"
#include "..\..\external\pxc\include\frame.h"

#include "tlVision.h"
#include "tlDigitizer.h"


// interface
class tlDigitizerPXC200 : public tlDigitizer
{
private:
  PXC             pxc;
  FRAMELIB        frame;
  long            fgHandle;
  FRAME __PX_FAR  *buffer;

public:
  tlDigitizerPXC200         ();
  tlDigitizerPXC200         (int width, int height);
  tlDigitizerPXC200         (int width, int height, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual ~tlDigitizerPXC200        ();

  virtual int open          (int index = 0);
  virtual int open          (int width, int height, int index = 0);
          int open          (int width, int height, int index, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual int close         ();

  virtual int setChannel    (int channel, unsigned short input);
  virtual int setInput      (unsigned short input);
  virtual int setFrameRate  (int fps);
  virtual int setSize       (int width, int height);

  virtual int grab          (tlImage *image);
  virtual int grab          (tlImage *image, tlRect *rect);
  virtual int grabQueued    (tlImage *image);
  virtual int grabQueued    (tlImage *image, tlRect *rect);
};

#endif

