/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Terry Fong, Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://imtsg14.epfl.ch/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLDIGITIZERV4L_H__
#define __TLDIGITIZERV4L_H__

/* LINUX is defined in the makefile */
#if    !LINUX
#error THIS IS A LINUX VERSION 
#endif

#define TLDIGITIZER_V4L_BASE_NAME "/dev/video"

#include <sys/types.h>
#include <linux/videodev.h>

#include "tlVision.h"
#include "tlDigitizer.h"


// interface
class tlDigitizerV4L : public tlDigitizer
{
private:
  int               ifd;
  unsigned char     *mmbuf;
  struct video_mbuf mbuf;
  struct video_mmap vbuf;
  unsigned char     *rgbImage;
  struct            video_capability vcap;
  int               grabQueuedInit;

public:
  tlDigitizerV4L  ();
  tlDigitizerV4L  (int width, int height);
  tlDigitizerV4L  (int width, int height, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual ~tlDigitizerV4L ();

  virtual int open         (int index = 0);
  virtual int open         (int width, int height, int index = 0);
  int         open         (int width, int height, int index, int channel, unsigned short input = TL_SOURCE_AUTO);
  virtual int close        ();

  virtual int setChannel   (int channel, unsigned short input);
  virtual int setInput     (unsigned short input);
  virtual int setFrameRate (int fps);
  virtual int setSize      (int width, int height);
  
  virtual int grab         (tlImage *image);
  virtual int grab         (tlImage *image, tlRect *rect);
  virtual int grabQueued   (tlImage *image);
  virtual int grabQueued   (tlImage *image, tlRect *rect);
};


#endif

