/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLDIGITIZERVRM_H__
#define __TLDIGITIZERVRM_H__



#include "tlVision.h"
#include "tlDigitizer.h"

#include "vrmusbcam2.h"



#define TL_DIGITIZERVRM_DEFAULT_WIDTH   720
#define TL_DIGITIZERVRM_DEFAULT_HEIGHT  556



// interface
class tlDigitizerVRm : public tlDigitizer
{
private:
  VRmUsbCamDevice device;

public:
  tlDigitizerVRm  ();
  virtual ~tlDigitizerVRm ();

  virtual int open            (int index = 0);
  virtual int close           ();

  // virtual int setChannel      (int channel, unsigned short input);
  // virtual int setInput        (unsigned short input);

  virtual int grab            (tlImage *image);
  virtual int grab            (tlImage *image, tlRect *rect);
  virtual int grabQueued      (tlImage *image);
  virtual int grabQueued      (tlImage *image, tlRect *rect);
};


#endif
