/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLEDGES_H__
#define __TLEDGES_H__


// edge extraction method
#define TL_EDGES_BIN        0
#define TL_EDGES_MORPH      1    
#define TL_EDGES_SOBEL      2
#define TL_EDGES_PREWITT    3


#include "tlVision.h"


// edge extraction
int tl_edges_bin          (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);

// vertical edge extraction
int tl_edges_vert_sobel   (tlPixel *src, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);
int tl_edges_vert_prewitt (tlPixel *src, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);

// horizontal edge extraction
int tl_edges_hor_sobel    (tlPixel *src, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);
int tl_edges_hor_prewitt  (tlPixel *src, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);


#endif
