/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLEXTRACT_H__
#define __TLEXTRACT_H__

#include "tlVision.h"
#include "tlHist2D.h"


#define TL_EXTRACT_DATA_DEPTH   4


#ifndef NO_DOC

// research structs
typedef struct {
  int       depth;
  int       px;
  int       py;
  int       width;
  int       height;
  int       *x1;
  int       *x2;
  int       *y1;
  int       *y2;
  int       lx1;
  int       lx2;
  int       ly1;
  int       ly2;
  int       connectivity;
  tlPixel   min[TL_EXTRACT_DATA_DEPTH];
  tlPixel   max[TL_EXTRACT_DATA_DEPTH];
  int       tol[TL_EXTRACT_DATA_DEPTH];
  tlPixel   *src;
  char      *objmap;
} tl_extract_data;

typedef struct {
  int      px;
  int      py;
  int      width;
  int      height;
  int      *x1;
  int      *x2;
  int      *y1;
  int      *y2;
  int      lx1;
  int      lx2;
  int      ly1;
  int      ly2;
  int      connectivity;
  tlPixel  *src;
  char     *objmap;
  tlHist2D *cmHist;
  int      threshold;
} tl_extract_data_cm;

#endif


// different color channel count generic recursive extraction
int tl_extract (tl_extract_data *data);

// different color channel count generic non-recursive extraction
int tl_extract_nr (tl_extract_data *data);

// color-model based recursive extraction
int tl_extract_cm_nrg (tl_extract_data_cm *data);
int tl_extract_cm_hsi (tl_extract_data_cm *data);


#endif
