/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLFILTER_H__
#define __TLFILTER_H__


#include "tlVision.h"



int tl_filter_rgb  (tlPixel *src, int width, int height, 
                    tlPixel r_min, tlPixel r_max,
                    tlPixel g_min, tlPixel g_max,
                    tlPixel b_min, tlPixel b_max,
                    tlRect *rect, tlPixel *dest,
                    tlPixel *mask = NULL);

int tl_filter_hsi  (tlPixel *src, int width, int height, 
                    tlPixel h1_min, tlPixel h1_max,
                    tlPixel h2_min, tlPixel h2_max,
                    tlPixel s_min, tlPixel s_max,
                    tlPixel i_min, tlPixel i_max,
                    tlRect *rect, tlPixel *dest,
                    tlPixel *mask = NULL);

int tl_filter_nrg  (tlPixel *src, int width, int height, 
                    tlPixel nr_min, tlPixel nr_max,
                    tlPixel ng_min, tlPixel ng_max,
                    tlRect *rect, tlPixel *dest,
                    tlPixel *mask = NULL);

int tl_filter_gray (tlPixel *src, int width, int height, 
                    tlPixel intensity_min, tlPixel intensity_max,
                    tlRect *rect, tlPixel *dest,
                    tlPixel *mask = NULL);

int tl_filter_hrgray (tlHRPixel *src, int width, int height, 
                      tlHRPixel intensity_min, tlHRPixel intensity_max,
                      tlRect *rect, tlHRPixel *dest,
                      tlPixel *mask = NULL);




int tl_extract_color_rgb      (tlPixel *src, int width, int height,
                               tlColor *minColor, tlColor *maxColor,
                               tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_min_rgb  (tlPixel *src, int width, int height,
                               tlColor *minColor, tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_max_rgb  (tlPixel *src, int width, int height,
                               tlColor *maxColor, tlRect *rect, tlPixel *mask = NULL);



int tl_extract_color_yuv      (tlPixel *src, int width, int height,
                               tlColor *minColor, tlColor *maxColor,
                               tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_min_yuv  (tlPixel *src, int width, int height,
                               tlColor *minColor, tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_max_yuv  (tlPixel *src, int width, int height,
                               tlColor *maxColor, tlRect *rect, tlPixel *mask = NULL);



int tl_extract_color_hsi      (tlPixel *src, int width, int height,
                               tlColor *minColor, tlColor *maxColor,
                               tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_min_hsi  (tlPixel *src, int width, int height,
                               tlColor *minColor, tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_max_hsi  (tlPixel *src, int width, int height,
                               tlColor *maxColor, tlRect *rect, tlPixel *mask = NULL);



int tl_extract_color_nrg      (tlPixel *src, int width, int height,
                               tlColor *minColor, tlColor *maxColor,
                               tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_min_nrg  (tlPixel *src, int width, int height,
                               tlColor *minColor, tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_max_nrg  (tlPixel *src, int width, int height,
                               tlColor *maxColor, tlRect *rect, tlPixel *mask = NULL);



int tl_extract_color_gray     (tlPixel *src, int width, int height,
                               tlColor *minColor, tlColor *maxColor,
                               tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_min_gray (tlPixel *src, int width, int height,
                               tlColor *minColor, tlRect *rect, tlPixel *mask = NULL);

int tl_extract_color_max_gray (tlPixel *src, int width, int height,
                               tlColor *maxColor, tlRect *rect, tlPixel *mask = NULL);


#endif
