/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLFORMATCONVERSION_H__
#define __TLFORMATCONVERSION_H__


#include "tlVision.h"



int tl_rgb2hsi  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_rgb2hsi  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_rgb2yuv  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_rgb2yuv  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_rgb2nrg  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_rgb2nrg  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_rgb2gray (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_rgb2gray (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_rgb2bin  (tlPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_rgb2bin  (tlPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_hsi2rgb  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_hsi2rgb  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_hsi2yuv  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_hsi2yuv  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_hsi2nrg  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_hsi2nrg  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_hsi2gray (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_hsi2gray (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_hsi2bin  (tlPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_hsi2bin  (tlPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_yuv2rgb  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_yuv2rgb  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_yuv2hsi  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_yuv2hsi  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_yuv2nrg  (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_yuv2nrg  (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_yuv2gray (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_yuv2gray (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_yuv2bin  (tlPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_yuv2bin  (tlPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_nrg2gray (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_nrg2gray (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_nrg2bin  (tlPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_nrg2bin  (tlPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_gray2rgb (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_gray2rgb (tlPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest);

int tl_gray2bin (tlPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_gray2bin (tlPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_hrgray2gray (tlHRPixel *src, int width, int height, tlRect *rect, tlPixel *dest, unsigned char shift = 0);
int tl_hrgray2gray (tlHRPixel *src, int width, int height, tlPixel *mask, tlRect *rect, tlPixel *dest, unsigned char shift = 0);

int tl_hrgray2bin (tlHRPixel *src, int width, int height, int min, int max, tlRect *rect, tlPixel *dest);
int tl_hrgray2bin (tlHRPixel *src, int width, int height, int min, int max, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_to_channel (tlPixel *src, int width, int height, int pixel_width, int channel, tlRect *rect, tlPixel *dest);
int tl_to_channel (tlPixel *src, int width, int height, int pixel_width, int channel, tlPixel *mask, tlRect *rect, tlPixel *dest);


int tl_put_channel (tlPixel *src, int width, int height, int pixel_width, int channel, tlRect *rect, tlPixel *dest);


#endif
