/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLLINE_H__
#define __TLLINE_H__


#include "tlVision.h"



// class declaration
class tlLine
{
public:
  float   theta, r;
  tlPoint *p1;
  tlPoint *p2;

public:
  // *structors
  tlLine ();
  tlLine (tlLine *line);
  tlLine (float theta, float r);
  tlLine (int x1, int y1, int x2, int y2);
  tlLine (tlPoint *p1, tlPoint *p2);
  virtual ~tlLine ();

  // definition
  int set (tlLine *line);
  int set (float theta, float r);
  int set (int x1, int y1, int x2, int y2);
  int set (tlPoint *p1, tlPoint *p2);

  // transforms
  int fit (tlChain *chain);

  // scaling
  int clip (tlRect *rect);
  int clip (int width, int height);

  // copy
  int copy   (tlLine *line);
  int copyTo (tlLine *line);
};



#endif
