/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLLOCATION_H__
#define __TLLOCATION_H__


#include "tlVision.h"


class tlLocation
{
public:

  // image location [pixel]
  int x;
  int y;
  int disp;

  // world location [m]
  float wx;
  float wy;
  float wz;

  
  // constructor
  tlLocation  ();
  tlLocation  (int x, int y, int disp = 0);
  virtual ~tlLocation ();

  // management
  int setLocation (int x, int y, int disp = 0);
  int setLocation (tlPoint *point);
  int shift       (int dx, int dy, int ddisp = 0);

  // set world location
  int setWorldLocation (float wx, float wy, float wz);

  // retrieval
  tlLocation *toLocation ();
  int         toLocation (tlLocation *location);
};


#endif

