/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLMORPH_H__
#define __TLMORPH_H__



#include "tlVision.h"



// thinning
int tl_thin            (tlPixel *src, int width, int height, tlRect *rect, tlPixel *dest);
int tl_thin_hitandmiss (tlPixel *src, int width, int height, tlPixel *kernel, tlRect *rect, tlPixel *dest);

// erosion
int tl_erode_all   (tlPixel *src, int width, int height, int pixel_width, int size, tlRect *rect, tlPixel *dest);
int tl_erode_gray  (tlPixel *src, int width, int height, int size, tlRect *rect, tlPixel *dest);
int tl_erode_bin   (tlPixel *src, int width, int height, int size, tlRect *rect, tlPixel *dest);

// dilatation
int tl_dilate_all  (tlPixel *src, int width, int height, int pixel_width, int size, tlRect *rect, tlPixel *dest);
int tl_dilate_gray (tlPixel *src, int width, int height, int size, tlRect *rect, tlPixel *dest);
int tl_dilate_bin  (tlPixel *src, int width, int height, int size, tlRect *rect, tlPixel *dest);



#endif
