/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLOBJECT_H__
#define __TLOBJECT_H__


#include "tlVision.h"
#include "tlPixelArray.h"



class tlObject : public tlPixelArray
{
public:
  tlMask *        shape;
  tlConst<float>* vx;
  tlConst<float>* vy;


  // constructors
  tlObject  ();
  tlObject  (tl_format format, int x, int y, int width, int height);
  virtual ~tlObject ();

  // management
  int copy   (tlObject *object);
  int copyTo (tlObject *object);

  // object definition
  int define      (tlImage *image, tlRect *rect);
  int define      (tlImage *image, tlColor *minColor, tlColor *maxColor, tlRect *rect);

  // data access
  tlPoint *getPredictedPosition ();
  int     getPredictedX ();
  int     getPredictedY ();

  // object extraction
  int extract       (tlImage *image, tlPoint *point, tlColor *gapColor, tlColor *varColor, int connex=TL_CONNEX_4);
  int extract       (tlImage *image, tlPoint *point, tlColor *gapColor, tlColor *varColor, tlRect *rect, int connex=TL_CONNEX_4);
  int extract       (tlImage *image, tlPoint *point, tlColorModel *colorModel, int threshold, int connex=TL_CONNEX_4);
  int extract       (tlImage *image, tlPoint *point, tlColorModel *colorModel, tlRect *rect, int threshold, int connex=TL_CONNEX_4);
};


#endif
