/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLPIXEL_H__
#define __TLPIXEL_H__


#include "tlVision.h"


// operations
int tl_pixel_add   (tlPixel *src, tlPixel *operand, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);
int tl_pixel_sub   (tlPixel *src, tlPixel *operand, int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);
int tl_pixel_scale (tlPixel *src, float factor,     int width, int height, int pixel_width, tlRect *rect, tlPixel *dest);

// high-res operations
int tl_pixel_hradd   (tlHRPixel *src, tlHRPixel *operand, int width, int height, int pixel_width, tlRect *rect, tlHRPixel *dest);
int tl_pixel_hrsub   (tlHRPixel *src, tlHRPixel *operand, int width, int height, int pixel_width, tlRect *rect, tlHRPixel *dest);
int tl_pixel_hrscale (tlHRPixel *src, float factor,       int width, int height, int pixel_width, tlRect *rect, tlHRPixel *dest);



#endif
