/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLPOINT_H__
#define __TLPOINT_H__


#include "tlVision.h"
#include "tlLocation.h"


class tlPoint : public tlLocation
{
public:

  // constructors
  tlPoint  ();
  tlPoint  (tlPoint *point);
  tlPoint  (int x, int y, int disp = 0);
  virtual ~tlPoint ();

  // point management
  int       copy        (tlPoint *point);
  int       copyTo      (tlPoint *point);
  tlPoint*  copy        ();

  // distance computation
  int dist (tlPoint *point);
  int dist (int x, int y);
};


#endif

