/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLRECT_H__
#define __TLRECT_H__

#include "tlVision.h"
#include "tlLocation.h"
#include "tlSize.h"


class tlRect : public tlSize, public tlLocation
{
public:

  // constructors
  tlRect  ();
  tlRect  (int x, int y, int width, int height);
  virtual ~tlRect ();

  // parameters
  int set (int x, int y, int width, int height);
  int set (tlPoint *p1, tlPoint *p2);
  int set (tlPoint *p1, int width, int height);

  // shift and resize
  int collapse (int dsize);
  int collapse (int dwidth, int dheight);
  int expand   (int dsize);
  int expand   (int dwidth, int dheight);

  // location
  int setCenter   (int x, int y);
  int setCenter   (tlPoint *p);

  // duplication
  int     copy   (tlRect *rect);
  int     copyTo (tlRect *rect);
  tlRect *copy   ();

  // intersection
  int intersect (tlRect *rect);
};


#endif

