/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSCALE_H__
#define __TLSCALE_H__


// edge extraction method
#define TL_SCALE_DECIMATE  0
#define TL_SCALE_BSPLINE   1


#include "tlVision.h"


// decimation scaling
tlPixel*   tl_scale_decimate (tlPixel *src, float factor, int width, int height, int pixel_width);
tlPixel*   tl_scale_decimate (tlPixel *src, int new_width, int new_height, int width, int height, int pixel_width);

// bspline scaling
int      tl_scale_bspline_init     (tlPixel *src, int width, int height, int pixel_width);
tlPixel *tl_scale_bspline          (float factor);
tlPixel *tl_scale_bspline          (int new_width, int new_height);
int      tl_scale_bspline_cleanup  ();


#endif
