/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSOURCE_H__
#define __TLSOURCE_H__


#include "tlVision.h"

// maximum number of image sources allowed
#define TL_MAX_SOURCE     10



// interface
class tlSource
{
protected:
  int       ID;
  int       width,height;
  tl_format format;
  static int count;

public:
  tlSource  ();
  virtual ~tlSource ();

  static int getCount () { return count; }

  int       getWidth  () { return width;  }
  int       getHeight () { return height; }
  int       getID     () { return ID;     }
  tl_format getFormat () { return format; }

  virtual int grab        (tlImage *image)                = 0;
  virtual int grab        (tlImage *image, tlRect *rect)  = 0;
  virtual int grabQueued  (tlImage *image)                = 0;
  virtual int grabQueued  (tlImage *image, tlRect *rect)  = 0;
};

#endif

