/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSOURCEFILES_H__
#define __TLSOURCEFILES_H__


#include "tlVision.h"
#include "tlSource.h"


// constants

// filename base used by the file "digitizer"
#define TL_SOURCEFILES_DEFAULT_FILENAME    "image"

// interface
class tlSourceFiles : tlSource
{
private:
  char *filenameBase;
  int  current;
  int  length;
  int  delay;
  long lastGrabTime;

public:
  tlSourceFiles  ();
  tlSourceFiles  (char *filename);
  virtual ~tlSourceFiles ();

  int getLength () { return length;  };
  int getIndex  () { return current; };

	int open     ();
  int open     (char *filename);
  int setIndex (int  index);
  
  int setFrameRate (int fps);

  virtual int grab        (tlImage *image);
  virtual int grab        (tlImage *image, tlRect *rect);
  virtual int grabQueued  (tlImage *image);
  virtual int grabQueued  (tlImage *image, tlRect *rect);
};

#endif


