/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSOURCEVIDEOFILE_H__
#define __TLSOURCEVIDEOFILE_H__



#include "tlVision.h"
#include "tlSource.h"



// DirectX objects
class DXFileObjects;



// interface
class tlSourceVideoFile : tlSource
{
private:
  char *filename;

  DXFileObjects  *grabber;
  char           *buffer;
  long           evCode;
  long           size;
  long long      length;
  long long      current;
  

public:
  tlSourceVideoFile  (char *filename);

  int getLength () { return (int)length;  };
  int getIndex  () { return (int)current; };

  int open     (char *filename);
  int close    ();
  int setFrame (int frame);

  virtual int grab        (tlImage *image);
  virtual int grab        (tlImage *image, tlRect *rect);
  virtual int grabQueued  (tlImage *image);
  virtual int grabQueued  (tlImage *image, tlRect *rect);
};

#endif

