/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLSPIRAL_H__
#define __TLSPIRAL_H__


#include "tlVision.h"

#include "tlPoint.h"


// class declaration
class tlSpiral
{
private:
  int x0,y0;
  int x,y;
  int nextX, nextY;
  int lastX, lastY;
  int width, height;
  int minX,maxX,minY,maxY;
  int done;
  int condX;
  int condY;
  int cur_incr;
  int x_incr;
  int y_incr;


public:

  // constructors
  tlSpiral  (tlRect *rect = NULL);
  tlSpiral  (int x0, int y0, int width, int height, tlRect *rect = NULL);
  tlSpiral  (tlPoint *p0,    int width, int height, tlRect *rect = NULL);
  virtual ~tlSpiral ();

  // init spiral
  int     init (int x0, int y0, int width, int height, tlRect *rect = NULL);
  int     init (tlPoint *p0,    int width, int height, tlRect *rect = NULL);

  // update spiral
  int     toNext  ();
  int     toNext  (tlPoint *point);
  
  // get spiral info
  tlPoint *get     ()                     { return new tlPoint (x,y); };
  int     get      (tlPoint *point)       { return point->setLocation (x,y); }
  int     getX     ()                     { return x; };
  int     getY     ()                     { return y; };
  int     getIndex ()                     { return y*width+x; };

  // get last spiral info
  tlPoint *getLast     ()                 { return new tlPoint (lastX, lastY); };
  int     getLast      (tlPoint *point)   { return point->setLocation (lastX, lastY); };
  int     getLastX     ()                 { return lastX; };
  int     getLastY     ()                 { return lastY; };
  int     getLastIndex ()                 { return lastY*width+lastX; };

  // get last spiral info
  tlPoint *getNext     ()                 { return new tlPoint (nextX, nextY); };
  int     getNext      (tlPoint *point)   { return point->setLocation (nextX, nextY); };
  int     getNextX     ()                 { return nextX; };
  int     getNextY     ()                 { return nextY; };
  int     getNextIndex ()                 { return nextY*width+nextX; };

};


#endif

