/////////////////////////////////////////////////////////////////////////////////
//
//  This file is part of the TLIB computer vision library.
//  Copyright (C) 2003-2008 Sebastien Grange
//  Copyright (C) 2003-2007 VRAI Group, EPFL
//  All rights reserved.
// 
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License("GPL") version 2
//  as published by the Free Software Foundation.
// 
//  <http://www.tuyphon.com/tlib>
//
/////////////////////////////////////////////////////////////////////////////////


#ifndef __TLTHREAD_H__
#define __TLTHREAD_H__

#include "tlVision.h"

#ifdef WIN32
#include <windows.h>
#define tlThreadHandle HANDLE
#endif

#ifdef LINUX
#define tlThreadHandle pthread_t
#define TLTHREAD_MAX	100	/* max # of threads */
#endif

typedef void (*TLTHREAD_FUNC_PTR)(void);

int  tlThreadCreate         (TLTHREAD_FUNC_PTR func, tlThreadHandle *handle);
void tlThreadExit           (int returnCode);
int  tlThreadKill           (tlThreadHandle *handle);
int  tlThreadChangePriority (tlThreadHandle *handle, int priority);
int  tlThreadJoin           (tlThreadHandle *handle, int *returnCode, int timeout);

// sleep (suspend current thread for a period)
void tlThreadSleep         (unsigned int msec);

#endif
